#include <stdio.h>
#include <stdlib.h>

int main()
{
    int a[20000],b[20000],n;
    scanf("%d",&n);
    for(int i=0;i<n;i++)
        scanf("%d",&a[i]);
    for(int i=0;i<n;i++)
        scanf("%d",&b[i]);
    int maks=0;
    int maxrez=-1,najA=0,najB=1;
    for(int i=0;i<n;i++)
    {
        if((najA^a[i])*(najB&b[i])>=a[i]*b[i])
        {
            maxrez=(najA^a[i])*(najB&b[i]);
            najA=najA^a[i];
            najB=najB&b[i];
        }
        else{
            maxrez=a[i]*b[i];
            najA=a[i];
            najB=b[i];
        }
        maks=(maks>maxrez)?maks:maxrez;

    }
    printf("%d",maks);

    return 0;
}